CREATE UNIQUE INDEX "DS2"."PK_CUSTOMERS" 
  ON "DS2"."CUSTOMERS"  ("CUSTOMERID")
  PARALLEL ( DEGREE DEFAULT )
  TABLESPACE "INDXTBS" 
  ;

ALTER TABLE "DS2"."CUSTOMERS" 
  ADD (CONSTRAINT "PK_CUSTOMERS" PRIMARY KEY("CUSTOMERID"))
  ; 

CREATE UNIQUE INDEX "DS2"."IX_CUST_USERNAME" 
  ON "DS2"."CUSTOMERS"  ("USERNAME") 
  PARALLEL ( DEGREE DEFAULT )
  TABLESPACE "INDXTBS" 
  ;

CREATE INDEX "DS2"."PK_CUST_HIST"
  ON "DS2"."CUST_HIST" ("CUSTOMERID")
  PARALLEL ( DEGREE DEFAULT )
  TABLESPACE "INDXTBS"
  ;

ALTER TABLE "DS2"."CUST_HIST"
  ADD (CONSTRAINT "FK_CUST_HIST_CUSTOMERID" FOREIGN KEY ("CUSTOMERID")
  REFERENCES "DS2"."CUSTOMERS" ("CUSTOMERID")
  ON DELETE CASCADE)
  ;

CREATE UNIQUE INDEX "DS2"."PK_ORDERS" 
  ON "DS2"."ORDERS"  ("ORDERID") 
  PARALLEL ( DEGREE DEFAULT )
  TABLESPACE "INDXTBS" 
  ;

ALTER TABLE "DS2"."ORDERS" 
  ADD (CONSTRAINT "PK_ORDERS" PRIMARY KEY("ORDERID"))
  ; 

ALTER TABLE "DS2"."ORDERS" 
  ADD (CONSTRAINT "FK_CUSTOMERID" FOREIGN KEY("CUSTOMERID") 
    REFERENCES "DS2"."CUSTOMERS"("CUSTOMERID")
    ON DELETE SET NULL)
  ;

CREATE UNIQUE INDEX "DS2"."PK_ORDERLINES" 
  ON "DS2"."ORDERLINES"  ("ORDERID", "ORDERLINEID") 
  PARALLEL ( DEGREE DEFAULT )
  TABLESPACE "INDXTBS" 
  ;

ALTER TABLE "DS2"."ORDERLINES" 
  ADD (CONSTRAINT "PK_ORDERLINES" PRIMARY KEY("ORDERID", "ORDERLINEID"))
  ; 

ALTER TABLE "DS2"."ORDERLINES"
  ADD (CONSTRAINT "FK_ORDERID" FOREIGN KEY("ORDERID") 
    REFERENCES "DS2"."ORDERS"("ORDERID"))
  ;

CREATE UNIQUE INDEX "DS2"."PK_PROD_ID" 
  ON "DS2"."PRODUCTS"  ("PROD_ID")
  PARALLEL ( DEGREE DEFAULT )
  TABLESPACE "INDXTBS" 
  ;

ALTER TABLE "DS2"."PRODUCTS" 
  ADD (CONSTRAINT "PK_PROD_ID" PRIMARY KEY("PROD_ID"))
  ; 

CREATE INDEX "DS2"."IX_PROD_CATEGORY"
  ON "DS2"."PRODUCTS"  ("CATEGORY")
  TABLESPACE "INDXTBS" 
  ;

CREATE INDEX "DS2"."IX_PROD_SPECIAL"
  ON "DS2"."PRODUCTS"  ("SPECIAL")
  TABLESPACE "INDXTBS" 
  ;

CREATE INDEX "DS2"."IX_INV_PROD_ID" 
  ON "DS2"."INVENTORY"  ("PROD_ID") 
  TABLESPACE "INDXTBS"
  ;

EXIT;
